<!--
 - Created by MarcelBrimus on 28/11/2019.
 -->

<!-- Vtt Lightning Community Management -->
<template>
    <div class="slds-form-element__control slds-p-bottom--medium" if:false={isVendorCommunityUser}>
        <template if:false={fetchingUserData}>
            <div class="slds-form-element__row">
                <div class="slds-form-element">
                    <label class="slds-form-element__label">
                        <abbr class="slds-required" title="required"></abbr>Company</label>
                    <div class="slds-form-element__control">
                        <lightning-combobox
                                variant="label-hidden"
                                placeholder="Please select account"
                                options={accounts}
                                value={selectedAccount}
                                onchange={onAccountChange}
                        ></lightning-combobox>
                    </div>
                </div>
            </div>
        </template>
    </div>
    <lightning-layout multiple-rows="true">
        <lightning-spinner size="small" if:true={fetchingUserData}></lightning-spinner>
        <lightning-layout-item flexibility="auto" size="12" small-device-size="12" medium-device-size="12"
                               large-device-size="12" class="slds-p-bottom--medium">
            <div class="slds-page-header">
                <div class="slds-page-header__row">
                    <div class="slds-page-header__col-title">
                        <div class="slds-media">
                            <div class="slds-media__figure">
          <span class="slds-icon_container slds-icon-standard-opportunity" title="opportunity">
            <lightning-icon icon-name="standard:account" alternative-text="Account"></lightning-icon>
            <span class="slds-assistive-text">opportunity</span>
          </span>
                            </div>
                            <div class="slds-media__body">
                                <div class="slds-page-header__name">
                                    <div class="slds-page-header__name-title">
                                        <h1>
                                    <span class="slds-page-header__title slds-truncate"
                                          title={userAccount.Name}>{userAccount.Name}</span>
                                        </h1>
                                    </div>
                                </div>

                                <p class="slds-page-header__name-meta">Total Licences: {userAccount.Total_Licenses__c} •
                                    Used
                                    Licences: {userAccount.Used_Licenses__c} • Remaining Licences:
                                    {userAccount.Remaining_Licenses__c}</p>

                            </div>
                        </div>
                    </div>
                    <div class="slds-page-header__col-actions">
                        <div class="slds-page-header__controls">
                            <div class="slds-page-header__control">
                                <lightning-button-icon icon-name="utility:loop"
                                                       variant="border-filled"
                                                       onclick={refreshPage}
                                                       alternative-text="Refresh"
                                                       class="slds-m-left_xx-small"></lightning-button-icon>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </lightning-layout-item>
        <lightning-layout-item flexibility="auto" size="12" small-device-size="12" medium-device-size="12"
                               large-device-size="12" class="slds-p-bottom--medium">
            <lightning-card title="Enabled Users">
                <lightning-spinner size="small" if:true={contactsLoading}></lightning-spinner>
                <div class="slds-scrollable" style="width: 100%; max-height:500px">
                    <table class="slds-table slds-table_cell-buffer slds-table_bordered">
                        <thead>
                        <tr class="slds-line-height_reset">
                            <th scope="col">
                                <div title="Action">Action</div>
                            </th>
                            <th scope="col">
                                <div title="Name">Name</div>
                            </th>
                            <th scope="col">
                                <div title="Vendor Portal User Role">Vendor Portal User Role</div>
                            </th>
                            <th scope="col">
                                <div title="User Name">User Name</div>
                            </th>
                            <template if:false={isVendorCommunityUser}>
                                <th scope="col">
                                    <div title="Status">Classic Or Lightning</div>
                                </th>
                            </template>
                        </tr>
                        </thead>
                        <tbody>
                        <template for:each={enabledContacts} for:item="contact">
                            <c-vtt_lightning_community_management_enabled-contact
                                    is-community-user={isVendorCommunityUser}
                                    contact={contact}
                                    key={contact.Id}></c-vtt_lightning_community_management_enabled-contact>
                        </template>
                        </tbody>
                    </table>
                </div>
            </lightning-card>
        </lightning-layout-item>
        <lightning-layout-item flexibility="auto" size="12" small-device-size="12" medium-device-size="12"
                               large-device-size="12">
            <lightning-card title="Disabled Users">
                <lightning-spinner size="small" if:true={contactsLoading}></lightning-spinner>
                <lightning-button label="New Contact" slot="actions" onclick={openmodal}></lightning-button>
                <div class="slds-scrollable" style="width: 100%; max-height:500px">
                    <table class="slds-table slds-table_cell-buffer slds-table_bordered">
                        <thead>
                        <tr class="slds-line-height_reset">
                            <th scope="col">
                                <div title="Name">Action</div>
                            </th>
                            <th scope="col">
                                <div title="Name">Name</div>
                            </th>
                            <th scope="col">
                                <div title="Email">Email</div>
                            </th>
                        </tr>
                        </thead>
                        <tbody>
                        <template for:each={disabledContacts} for:item="contact">
                            <c-vtt_lightning_community_management_disabled-contact contact={contact}
                                                                                   key={contact.Id}></c-vtt_lightning_community_management_disabled-contact>
                        </template>
                        </tbody>
                    </table>
                </div>
            </lightning-card>
        </lightning-layout-item>
    </lightning-layout>

    <template if:true={showModal}>
        <section
                role="dialog"
                tabindex="-1"
                aria-labelledby="modal-heading-01"
                aria-modal="true"
                aria-describedby="modal-content-id-1"
                class="slds-modal slds-fade-in-open slds-modal_medium">
            <div class="slds-modal__container">
                <div class="slds-is-relative">
                    <lightning-spinner size="small" if:true={savingContact}></lightning-spinner>
                    <header class="slds-modal__header">
                        <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse"
                                onclick={closeModal}
                                title="Close">
                            <lightning-icon icon-name="utility:close"
                                            size="small"></lightning-icon>
                            <span class="slds-assistive-text">
						Close
					</span>
                        </button>
                        <h2 id="modal-heading-01-small"
                            class="slds-text-heading_medium slds-hyphenate">New Contact</h2>
                    </header>
                    <div class="slds-modal__content slds-p-around_medium"
                         id="modal-content-id-1" style="max-height: 500px">

                        <lightning-record-edit-form
                                object-api-name="Contact"
                                density="comfy"
                                onsuccess={handleSaveSuccess}>
                            <lightning-messages>
                            </lightning-messages>
                            <div class="slds-form__row">

                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='AccountId' disabled
                                                           value={selectedAccount}></lightning-input-field>
                                </div>
                                <div style="display:none">
                                    <lightning-input-field field-name="Name"></lightning-input-field>
                                </div>
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='Salutation'></lightning-input-field>
                                </div>
                            </div>
                            <div class="slds-form__row">
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='FirstName'></lightning-input-field>
                                </div>
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='LastName'></lightning-input-field>
                                </div>
                            </div>
                            <div class="slds-form__row">
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='Title'></lightning-input-field>
                                </div>
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='User__c'></lightning-input-field>
                                </div>
                            </div>
                            <div class="slds-form__row">
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='Email'></lightning-input-field>
                                </div>
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='Phone'></lightning-input-field>
                                </div>
                            </div>
                            <div class="slds-form__row">
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='MobilePhone'></lightning-input-field>
                                </div>
                                <div class="slds-form__item" role="listitem">
                                    <lightning-input-field field-name='HomePhone'></lightning-input-field>
                                </div>
                            </div>
                            <lightning-input-field field-name='MailingAddress'></lightning-input-field>
                            <div if:false={isVendorCommunityUser}>
                                <lightning-input-field class="slds-hidden"
                                                       field-name='RecordTypeId'
                                                       value={recordType}></lightning-input-field>
                            </div>

                            <lightning-button-group class="slds-align_absolute-center">
                                <lightning-button label="Save"
                                                  type="submit"
                                                  variant="Success"
                                ></lightning-button>
                                <lightning-button label="Cancel"
                                                  variant="Neutral"
                                                  onclick={closeModal}></lightning-button>

                            </lightning-button-group>

                        </lightning-record-edit-form>
                    </div>
                </div>
            </div>
        </section>
        <div class="slds-backdrop slds-backdrop_open"></div>
    </template>
</template>